<!-- $Id: tFTP_perl.xml 1528 2007-01-19 17:03:36 +0000 (星期五, 19 一月 2007) smallet $ -->
<COMPONENT>
  <HEADER
    PLATEFORM="ALL"
       SERIAL=""
      VERSION="0.101"
       STATUS="ALPHA"

    COMPATIBILITY="ALL"
    AUTHOR="Talend"
    RELEASE_DATE="20050320A"
    STARTABLE="true"
	  PARTITIONING="AUTO"
    LOG4J_ENABLED="true"
  >
    <SIGNATURE></SIGNATURE>
  </HEADER>

  <FAMILIES>
    <FAMILY>Internet/FTP</FAMILY>
  </FAMILIES>

  <DOCUMENTATION>
    <URL/>
  </DOCUMENTATION>
  <CONNECTORS>
    <CONNECTOR CTYPE="FLOW" MAX_INPUT="1" MAX_OUTPUT="1"/>
    <CONNECTOR CTYPE="ITERATE" MAX_OUTPUT="1" MAX_INPUT="1"/>
    <CONNECTOR CTYPE="SUBJOB_OK" MAX_INPUT="1" />
    <CONNECTOR CTYPE="SUBJOB_ERROR" MAX_INPUT="1" />
    <CONNECTOR CTYPE="COMPONENT_OK"/>
    <CONNECTOR CTYPE="COMPONENT_ERROR"/>
    <CONNECTOR CTYPE="RUN_IF"/>
  </CONNECTORS>

  <PARAMETERS>

  <PARAMETER NAME="PROPERTY" FIELD="PROPERTY_TYPE" SHOW="true"
			NUM_ROW="1" REPOSITORY_VALUE="FTP"/>

			<PARAMETER NAME="REPOSITORY_ALLOW_AUTO_SWITCH" FIELD="CHECK" SHOW="false" REQUIRED="true"
			NUM_ROW="1"/>

      <PARAMETER
      NAME="USE_EXISTING_CONNECTION"
      FIELD="CHECK"
      NUM_ROW="2"
      >
      <DEFAULT>false</DEFAULT>
    </PARAMETER>

    <PARAMETER
      NAME="CONNECTION"
      FIELD="COMPONENT_LIST"
      REQUIRED="true" FILTER="tFTPConnection"
      NUM_ROW="2"
      SHOW_IF="USE_EXISTING_CONNECTION == 'true'"
    />

    <PARAMETER
    	NAME="HOST"
    	FIELD="TEXT"
    	REQUIRED="true"
    	NUM_ROW="11"
    	REPOSITORY_VALUE="SERVER_NAME"
    	SHOW_IF="USE_EXISTING_CONNECTION == 'false'"
    	>
      <DEFAULT>"localhost"</DEFAULT>
    </PARAMETER>

    <PARAMETER
    	NAME="PORT"
    	FIELD="TEXT"
    	REQUIRED="true"
    	NUM_ROW="11"
    	REPOSITORY_VALUE="PORT"
    	SHOW_IF="(USE_EXISTING_CONNECTION == 'false') AND (FTPS == 'false')"
    	>
      <DEFAULT>21</DEFAULT>
    </PARAMETER>

    <PARAMETER
      NAME="FTPS_PORT"
      FIELD="TEXT"
      REQUIRED="true"
      NUM_ROW="11"
      SHOW_IF="(USE_EXISTING_CONNECTION == 'false') AND (FTPS == 'true')"
      REPOSITORY_VALUE="PORT"
    >
      <DEFAULT>990</DEFAULT>
    </PARAMETER>

    <PARAMETER
    	NAME="USERNAME"
    	FIELD="TEXT"
    	REQUIRED="true"
    	NUM_ROW="21"
    	REPOSITORY_VALUE="USERNAME"
    	SHOW_IF="USE_EXISTING_CONNECTION == 'false'"
    	>
      <DEFAULT>"anonymous"</DEFAULT>
    </PARAMETER>

    <PARAMETER
    	NAME="PASSWORD"
    	FIELD="PASSWORD"
    	REQUIRED="true"
    	NUM_ROW="21"
    	REPOSITORY_VALUE="PASSWORD"
    	NOT_SHOW_IF="((SFTP=='true') AND (AUTH_METHOD == 'PUBLICKEY')) OR (USE_EXISTING_CONNECTION == 'true')"
    	>
      <DEFAULT>"suomynona"</DEFAULT>
    </PARAMETER>

    <PARAMETER NAME="SFTP" FIELD="CHECK" REQUIRED="true" NUM_ROW="41" REPOSITORY_VALUE="SFTP" SHOW_IF="(USE_EXISTING_CONNECTION == 'false') AND (FTPS == 'false')">
      <DEFAULT>false</DEFAULT>
    </PARAMETER>

    <PARAMETER NAME="FTPS" FIELD="CHECK" REQUIRED="true" NUM_ROW="41" REPOSITORY_VALUE="FTPS" SHOW_IF="(USE_EXISTING_CONNECTION == 'false') AND (SFTP == 'false')">
      <DEFAULT>false</DEFAULT>
    </PARAMETER>

    <PARAMETER
      NAME="AUTH_METHOD"
      FIELD="CLOSED_LIST"
      NUM_ROW="41"
      REPOSITORY_VALUE="AUTH_METHOD"
      SHOW_IF="(SFTP=='true') AND (USE_EXISTING_CONNECTION == 'false')"
    >
      <ITEMS DEFAULT="PASSWORD">
        <ITEM NAME="PUBLICKEY"  VALUE="PUBLICKEY"/>
        <ITEM NAME="PASSWORD"   VALUE="PASSWORD"/>
      </ITEMS>
    </PARAMETER>

    <PARAMETER
      NAME="PRIVATEKEY"
      FIELD="FILE"
      NUM_ROW="22"
      SHOW_IF="(SFTP=='true') AND (AUTH_METHOD == 'PUBLICKEY')  AND (USE_EXISTING_CONNECTION == 'false')"
      REPOSITORY_VALUE="PRIVATEKEY"
    >
      <DEFAULT>"/.ssh/id_dsa"</DEFAULT>
    </PARAMETER>

	<PARAMETER
      NAME="PASSPHRASE"
      FIELD="PASSWORD"
      NUM_ROW="23"
      SHOW_IF="(SFTP=='true') AND (AUTH_METHOD == 'PUBLICKEY')  AND (USE_EXISTING_CONNECTION == 'false')"
      REPOSITORY_VALUE="PASSPHRASE"
    >
      <DEFAULT>"secret"</DEFAULT>
    </PARAMETER>

    <PARAMETER
      NAME="KEYSTORE_FILE"
      FIELD="FILE"
      NUM_ROW="25"
      SHOW_IF="(FTPS=='true') AND (USE_EXISTING_CONNECTION == 'false')"
      REPOSITORY_VALUE="KEYSTORE_FILE"
    >
      <DEFAULT>""</DEFAULT>
    </PARAMETER>

    <PARAMETER
      NAME="KEYSTORE_PASS"
      FIELD="PASSWORD"
      NUM_ROW="26"
      SHOW_IF="(FTPS=='true') AND (USE_EXISTING_CONNECTION == 'false')"
      REPOSITORY_VALUE="KEYSTORE_PASS"
    >
      <DEFAULT>"123456"</DEFAULT>
    </PARAMETER>
    
    <PARAMETER NAME="REMOTEDIR" FIELD="TEXT" REQUIRED="false" NUM_ROW="31">
      <DEFAULT>"."</DEFAULT>
    </PARAMETER>

    <PARAMETER NAME="MOVE_TO_THE_CURRENT_DIRECTORY" FIELD="CHECK" NUM_ROW="31" SHOW_IF="USE_EXISTING_CONNECTION == 'true'">
      <DEFAULT>true</DEFAULT>
    </PARAMETER>

    <PARAMETER NAME="PERL5_REGEX" FIELD="CHECK" REQUIRED="false" NUM_ROW="50">
        <DEFAULT>false</DEFAULT>
    </PARAMETER>

    <PARAMETER NAME="FILES" FIELD="TABLE" REQUIRED="false" NUM_ROW="51" NB_LINES="5">
      <ITEMS>
        <ITEM NAME="FILEMASK" />
      </ITEMS>
    </PARAMETER>
    <PARAMETER NAME="TARGET_TYPE" FIELD="CLOSED_LIST" NUM_ROW="56">
      <ITEMS DEFAULT="FILE">
        <ITEM NAME="FILE"  VALUE="FILE" />
     	<ITEM NAME="DIRECTORY"  VALUE="DIRECTORY" />
      </ITEMS>
    </PARAMETER>
    <PARAMETER NAME="CONNECT_MODE" FIELD="CLOSED_LIST" NUM_ROW="101" REPOSITORY_VALUE="CONNECT_MODE" SHOW_IF="(SFTP=='false') AND (USE_EXISTING_CONNECTION == 'false')">
      <ITEMS DEFAULT="PASSIVE">
        <ITEM NAME="PASSIVE"  VALUE="PASSIVE" />
     	<ITEM NAME="ACTIVE"  VALUE="ACTIVE" />
      </ITEMS>
    </PARAMETER>

    <PARAMETER NAME="SECURITY_MODE" FIELD="CLOSED_LIST" NUM_ROW="102" REPOSITORY_VALUE="SECURITY_MODE" SHOW_IF="(USE_EXISTING_CONNECTION == 'false') AND (FTPS == 'true')">
      <ITEMS DEFAULT="IMPLICIT">
        <ITEM NAME="IMPLICIT"  VALUE="IMPLICIT" />
        <ITEM NAME="EXPLICIT"  VALUE="EXPLICIT" />
      </ITEMS>
    </PARAMETER>

    <PARAMETER
      NAME="USE_ENCODING"
      FIELD="CHECK"
      NUM_ROW="105"
      REPOSITORY_VALUE="USE_ENCODING"
      REQUIRED="true" SHOW_IF="(USE_EXISTING_CONNECTION == 'false') and (SFTP == 'true')">
       <DEFAULT>false</DEFAULT>
    </PARAMETER>

    <PARAMETER
      NAME="ENCODING"
      FIELD="ENCODING_TYPE"
      NUM_ROW="111"
      REQUIRED="true"
      REPOSITORY_VALUE="ENCODING"
      NOT_SHOW_IF="(USE_EXISTING_CONNECTION == 'true') or ((SFTP == 'true') and (USE_ENCODING == 'false'))">
       <DEFAULT>"ISO-8859-15"</DEFAULT>
    </PARAMETER>


    <PARAMETER
      NAME="DIE_ON_ERROR"
      FIELD="CHECK"
      NUM_ROW="121"
    >
      <DEFAULT>true</DEFAULT>
    </PARAMETER>
  </PARAMETERS>

	<ADVANCED_PARAMETERS>

		<PARAMETER NAME="USE_PROXY" FIELD="CHECK" REQUIRED="true"
			NUM_ROW="86" REPOSITORY_VALUE="USE_PROXY" SHOW_IF="USE_EXISTING_CONNECTION == 'false'">
			<DEFAULT>false</DEFAULT>
		</PARAMETER>

		<PARAMETER NAME="PROXY_HOST" FIELD="TEXT"
			NUM_ROW="87" SHOW_IF="(USE_EXISTING_CONNECTION == 'false') AND (USE_PROXY == 'true')" REPOSITORY_VALUE="PROXY_HOST">
			<DEFAULT>"61.163.92.4"</DEFAULT>
		</PARAMETER>
		<PARAMETER NAME="PROXY_PORT" FIELD="TEXT"
			NUM_ROW="88" SHOW_IF="(USE_EXISTING_CONNECTION == 'false') AND (USE_PROXY == 'true')" REPOSITORY_VALUE="PROXY_PORT">
			<DEFAULT>"1080"</DEFAULT>
		</PARAMETER>

		<PARAMETER NAME="PROXY_USERNAME" FIELD="TEXT"
			NUM_ROW="89" SHOW_IF="(USE_EXISTING_CONNECTION == 'false') AND (USE_PROXY == 'true')" REPOSITORY_VALUE="PROXY_USERNAME">
			<DEFAULT>""</DEFAULT>
		</PARAMETER>
		<PARAMETER NAME="PROXY_PASSWORD" FIELD="PASSWORD"
			NUM_ROW="90" SHOW_IF="(USE_EXISTING_CONNECTION == 'false') AND (USE_PROXY == 'true')" REPOSITORY_VALUE="PROXY_PASSWORD">
			<DEFAULT>""</DEFAULT>
		</PARAMETER>

		<PARAMETER NAME="IGNORE_FAILURE_AT_QUIT" FIELD="CHECK" REQUIRED="true"
			NUM_ROW="91" SHOW_IF="(((USE_EXISTING_CONNECTION == 'true') AND (#LINK@NODE.CONNECTION.SFTP == 'false') AND (#LINK@NODE.CONNECTION.FTPS == 'false')) OR ((USE_EXISTING_CONNECTION == 'false') AND (SFTP=='false') AND (FTPS=='false')))">
			<DEFAULT>false</DEFAULT>
		</PARAMETER>

		<PARAMETER NAME="FTPS_PROT" FIELD="OPENED_LIST"
			NUM_ROW="92" SHOW_IF="(FTPS=='true') AND (USE_EXISTING_CONNECTION == 'false')" REPOSITORY_VALUE="FTPS_PROT">
			<ITEMS DEFAULT="PRIVATE">
				<ITEM NAME="CLEAR" VALUE="&quot;C&quot;" />
				<ITEM NAME="SAFE" VALUE="&quot;S&quot;" />
				<ITEM NAME="CONFIDENTIAL" VALUE="&quot;E&quot;" />
				<ITEM NAME="PRIVATE" VALUE="&quot;P&quot;" />
			</ITEMS>
		</PARAMETER>

		<PARAMETER NAME="FTPS_PROTECTION_BUFF_SIZE" FIELD="TEXT"
			NUM_ROW="92" SHOW_IF="(FTPS=='true') AND (USE_EXISTING_CONNECTION == 'false')" REPOSITORY_VALUE="FTPS_PROTECTION_BUFF_SIZE">
			<DEFAULT>0</DEFAULT>
		</PARAMETER>

		<PARAMETER NAME="REMOTE_VERIFICATION" FIELD="CHECK"
			NUM_ROW="95" SHOW_IF="(FTPS=='true') AND (USE_EXISTING_CONNECTION == 'false')" REPOSITORY_VALUE="REMOTE_VERIFICATION">
			<DEFAULT>true</DEFAULT>
		</PARAMETER>

		<PARAMETER NAME="CONNECTION_TIMEOUT" FIELD="TEXT"
			NUM_ROW="96" SHOW_IF="USE_EXISTING_CONNECTION == 'false'" REPOSITORY_VALUE="CONNECTION_TIMEOUT">
			<DEFAULT>0</DEFAULT>
		</PARAMETER>
	</ADVANCED_PARAMETERS>

  <CODEGENERATION>
     <IMPORTS>
		<IMPORT NAME="Java-FTP" MODULE="edtftpj-2.5.0.jar" MVN="mvn:com.enterprisedt/edtftpj/2.5.0" REQUIRED_IF="(SFTP == 'false') AND (FTPS == 'false') AND (USE_EXISTING_CONNECTION == 'false')"/>
		<IMPORT NAME="Java-SFTP" MODULE="jsch-0.1.55.jar" MVN="mvn:com.jcraft/jsch/0.1.55" REQUIRED_IF="(SFTP == 'true') AND (USE_EXISTING_CONNECTION == 'false')"/>
		<IMPORT NAME="jakarta-oro" MODULE="jakarta-oro-2.0.8.jar" MVN="mvn:org.talend.libraries/jakarta-oro-2.0.8/6.0.0"  UrlPath="platform:/plugin/org.talend.libraries.apache/lib/jakarta-oro-2.0.8.jar" REQUIRED="true" />
		<IMPORT NAME="Java-FTPS" MODULE="commons-net-3.6.jar" MVN="mvn:commons-net/commons-net/3.6" REQUIRED_IF="(FTPS == 'true') AND (USE_EXISTING_CONNECTION == 'false')" />
		<IMPORT NAME="Java-FTPS-talend" MODULE="commons-net-ftps-proxy-3.6.1-talend-20190819.jar" 
			MVN="mvn:org.talend.components.lib/commons-net-ftps-proxy/3.6.1-talend-20190819" 
			REQUIRED_IF="(FTPS == 'true') AND (USE_EXISTING_CONNECTION == 'false')" />
		<IMPORT NAME="talend-proxy" MODULE="talend-proxy-1.0.0.jar" MVN="mvn:org.talend.components.lib/talend-proxy/1.0.0" REQUIRED_IF="(USE_EXISTING_CONNECTION == 'false') AND ((FTPS == 'true') OR (SFTP == 'true'))" />
     </IMPORTS>
   </CODEGENERATION>
  <RETURNS>
  	 <RETURN NAME="NB_FILE" TYPE="id_Integer" AVAILABILITY="AFTER"/>
  	 <RETURN NAME="CURRENT_STATUS" TYPE="id_String" AVAILABILITY="FLOW"/>
  </RETURNS>
</COMPONENT>
